#!/usr/bin/env python

"A simple Zope product."

from Simple import SimpleResource
from WebStack.Resources.LoginRedirect import LoginRedirectResource, LoginRedirectAuthenticator
from WebStack.Resources.Login import LoginResource, LoginAuthenticator
from WebStack.Resources.ResourceMap import MapResource
from WebStack.Adapters.Zope import WebStackAdapterProduct
from Globals import InitializeClass

# Change this to be the URL base for your server.
# eg. http://localhost:8000

app_url = "http://localhost" # No trailing "/"!

# Must match the key used elsewhere.

secret_key = "horses"

class SimpleWithLoginProduct(WebStackAdapterProduct):

    meta_type = "Simple with login product"

    def __init__(self, id, parent_url):
        login_url = parent_url + "/" + id + "/login"
        resource = get_site_map(app_url, login_url, secret_key)
        WebStackAdapterProduct.__init__(self, id, resource)

InitializeClass(SimpleWithLoginProduct)

def addSimpleWithLoginProduct(self):
    """
    The HTML form used to add the product.
    """

    return """
        <html>
            <head>
                <title>Add Simple with Login Product</title>
            </head>
            <body>
                <form action="addProduct">
                    id <input name="id" type="text"><br>
                    <input name="add" type="submit" value="Add!">
                </form>
            </body>
        </html>
        """

def addProduct(self, id, REQUEST=None):
    """
    The function used to add the product.
    """

    product = SimpleWithLoginProduct(id, self.DestinationURL())
    self.Destination()._setObject(id, product)
    if REQUEST:
        return self.manage_main(self, REQUEST)

def initialize(context):
    context.registerClass(
        SimpleWithLoginProduct,
        constructors = (addSimpleWithLoginProduct, addProduct)
    )

# vim: tabstop=4 expandtab shiftwidth=4
